#include <stdio.h>
#include <fstream>
#include <iostream>
#include "evaluationConfigurerations.h"
#include "paramSimul.h"
#include "objectBSSectorUe.h"
#include "ue.h"



using namespace std;


double trans_azimuth_angle_minus_180_to_180(double x);
double trans_zenith_angle_0_to_180(double x);

void Calculate_UE_Sector_angle()
{
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		if (test_environment <3)
		{

		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			
		}
		else
		{
			for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
			{
				double azimuth_angle = atan2(ue[ue_idx].pos[bs_idx].y, ue[ue_idx].pos[bs_idx].x) * 180. / PI;

				double height = h_BS - ue[ue_idx].h_UT;

				double zenith_angle = trans_zenith_angle_0_to_180(atan2(height, ue[ue_idx]._2D_distance[bs_idx]) * 180. / PI + 90);

				ue[ue_idx].phi_LOS_AOA[3 * bs_idx] = trans_azimuth_angle_minus_180_to_180(azimuth_angle - 30);
				ue[ue_idx].phi_LOS_AOA[3 * bs_idx + 1] = trans_azimuth_angle_minus_180_to_180(azimuth_angle - 150);
				ue[ue_idx].phi_LOS_AOA[3 * bs_idx + 2] = trans_azimuth_angle_minus_180_to_180(azimuth_angle - 270);

				ue[ue_idx].theta_LOS_ZOA[3 * bs_idx] = zenith_angle;
				ue[ue_idx].theta_LOS_ZOA[3 * bs_idx + 1] = zenith_angle;
				ue[ue_idx].theta_LOS_ZOA[3 * bs_idx + 2] = zenith_angle;

				if (carrier_freq < 6000000000)
				{
					ue[ue_idx].phi_LOS_AOD[3 * bs_idx] = 0;
					ue[ue_idx].phi_LOS_AOD[3 * bs_idx + 1] = 0 ;
					ue[ue_idx].phi_LOS_AOD[3 * bs_idx + 2] = 0;


					ue[ue_idx].theta_LOS_ZOD[3 * bs_idx] = 0;
					ue[ue_idx].theta_LOS_ZOD[3 * bs_idx + 1] = 0 ;
					ue[ue_idx].theta_LOS_ZOD[3 * bs_idx + 2] = 0;
				}
				else
				{
					ue[ue_idx].bearing_angle = Rand.u() * 360 - 180;


					ue[ue_idx].phi_LOS_AOD[3 * bs_idx] = trans_azimuth_angle_minus_180_to_180(azimuth_angle + 180 - ue[ue_idx].bearing_angle);
					ue[ue_idx].phi_LOS_AOD[3 * bs_idx + 1] = trans_azimuth_angle_minus_180_to_180(azimuth_angle + 180 - ue[ue_idx].bearing_angle);
					ue[ue_idx].phi_LOS_AOD[3 * bs_idx + 2] = trans_azimuth_angle_minus_180_to_180(azimuth_angle + 180 - ue[ue_idx].bearing_angle);
					
					ue[ue_idx].theta_LOS_ZOD[3 * bs_idx] = trans_zenith_angle_0_to_180(180 - zenith_angle);
					ue[ue_idx].theta_LOS_ZOD[3 * bs_idx + 1] = trans_zenith_angle_0_to_180(180 - zenith_angle);
					ue[ue_idx].theta_LOS_ZOD[3 * bs_idx + 2] = trans_zenith_angle_0_to_180(180 - zenith_angle);

				}

			}

		}
	}
}

double trans_azimuth_angle_minus_180_to_180( double x)
{
	x = fmod(x, 360);

	if (x < 0)
	{
		x = x + 360;
	}

	x = x - 360 * floor(x / 180);

	return x;
}

double trans_zenith_angle_0_to_180(double x)
{
	x = fmod(x, 360);

	if (x < 0)
	{
		x = x + 360;
	}

	x = abs(x - 360 * floor(x / 180));

	return x;
}
