#include "paramSimul.h"
#include "objectBSSectorUe.h"

bool LOS_condition = false;


void Generate_pathloss()
{
	for(int ue_idx=0; ue_idx<num_ue; ue_idx++)
	{
		
		for(int bs_idx = 0; bs_idx<num_bs; bs_idx++)
		{
			ue[ue_idx].Determine_LOS(bs_idx);
			ue[ue_idx].Set_breakpoint_distance(bs_idx);

		}
		 
		
		
		if (calibration == 1)
		{
			if (LOS_condition == true)
			{
				for (int bs_idx = 0; bs_idx<num_bs; bs_idx++)
				{
					ue[ue_idx].LOS_condition[bs_idx] = LOS;
					ue[ue_idx].propagation_condition[bs_idx] = LOS;;
				}
			}
			else
			{
				for (int bs_idx = 0; bs_idx<num_bs; bs_idx++)
				{
					ue[ue_idx].LOS_condition[bs_idx] = NLOS;
					ue[ue_idx].propagation_condition[bs_idx] = NLOS;;
				}
			}

		}
				
		for (int bs_idx = 0; bs_idx<num_bs; bs_idx++)
		{
			ue[ue_idx].Compute_PathLoss(bs_idx);
		}
	}
	
}
