#ifndef _PARAMSIMUL_H_
#define _PARAMSIMUL_H_

#include "rvGenerater.h"

extern struct Rand Rand;
extern unsigned long _seed;
extern bool calibration;

extern int t;
extern int run_times;


extern int drop_idx;
extern int num_drops;
extern int num_ue;
extern int num_bs;
extern int num_sector;
extern int num_user_per_sector;

extern int bs_antenna_array_type;

extern int P_bs;
extern int Mg_bs;
extern int Ng_bs;
extern int dg_H_bs;
extern int dg_V_bs;
extern int M_bs;
extern int N_bs;

extern int ue_antenna_array_type;

extern int P_ue;
extern int Mg_ue;
extern int Ng_ue;
extern int dg_H_ue;
extern int dg_V_ue;
extern int M_ue;
extern int N_ue;

extern int num_rx_antenna_element;
extern int num_tx_antenna_element;
extern int pathloss_model;
extern int test_environment;
extern int num_compute_coef;

extern int num_neighbor;
extern double grid_interval;

extern double carrier_freq;
extern double lamda_0;


extern char *file_name;
extern char path[100];


extern int wrap[19][19];



#endif